View Issue Details

IDProjectCategoryView StatusLast Update
0001905WishesViewerpublic2013-03-19 07:50
ReporterDrKnS Assigned To2useven10  
PrioritynormalSeverityfeatureReproducibilityN/A
Status closedResolutionfixed 
Target Version3.0Fixed in Version3.0 
Summary0001905: viewer dump mode
Descriptionhttp://bugs.farmanager.com/view.php?id=1766#c7539

> А давайте во вьювер режим дампа добавим?
> Т.е. без обработки переносов строк и табуляций.
> F4, циклично: text - hex - dump

> Типа HEX'а, но без HEX'а.


> версию с дамповым режимом просмотра можно попробовать:
> http://sharapov-16.narod.ru/far/index.html

TagsNo tags attached.
Build3256

Activities

2useven10

2011-10-17 21:02

developer   bugnote:0007885

Last edited: 2011-10-17 21:07

View 3 revisions

Пробуем...
http://mini-gnu.googlecode.com/files/Far3-Mantis1905-64.7z
http://mini-gnu.googlecode.com/files/Far3-Mantis1905-32.7z
мнения и баг репорты приветствуются

'интеллект' текст-дамп; меню выбора на ShiftF4; конфиг; видимый '\0';
-баги для .1st

Maximus

2011-10-17 21:08

reporter   bugnote:0007886

Last edited: 2011-10-17 21:13

View 2 revisions

а патчик для текущего фара можно? а то как-то не интересно "чужими", без MANTIS_0001687, да еще и не отладочными сборками пользоваться )

если смотреть то, что было раньше (и собрано у меня) - вроде норм.

Единственно, что, хотелось бы какую-то заметную индикацию, какой режим в настоящий момент работает. Может в заголовке (статусе)?

Maximus

2011-10-17 21:10

reporter   bugnote:0007887

И в макросах "Viewer.State" не различается (Hex/Dump)

2useven10

2011-10-17 21:14

developer   bugnote:0007888

Last edited: 2011-10-17 21:18

View 2 revisions

http://mini-gnu.googlecode.com/files/1905-diff.7z
различается: 0x40 - dump mode
индикацию и мне хотелось бы, не знаю куда поставить...

Maximus

2011-10-17 21:25

reporter   bugnote:0007889

пардон муа, жмакая F4 не заметил, что режимов поубавилось

тогда непонятно, флажка "Dump mode" уже нет, то есть фар сам за юзера решает, нужен ли ему дамп? некошерно как-то. если для exe-шников просмотр как text действительно (или возможно?) не нужен, то для текстовых файлов - может быть интересно посмотреть именно дамп. Кроме того при листаниях файлов (Add/Subtract) может быть важно сохранение режима.

Режим у меня сохранялся макросом

macro
  Description="Листание файлов с сохранением Hex режима"
  Key="Add Subtract"
  Area="Viewer"
{{
  %s = Viewer.State;
  // Нажать Gray+ или Gray-
  eval(Key(#AKey))
  // Установить тот же Hex-режим
  $if ((%s & 0x20) != (Viewer.State & 0x20))
    F4
  $end
}}

сейчас он "полетит, т.к. набор режимом разных файлов больше не будут совпадать.

Maximus

2011-10-17 21:34

reporter   bugnote:0007890

Last edited: 2011-10-17 21:35

View 2 revisions

- DialogItemEx *SavePos = Builder.AddCheckbox(MViewConfigSavePos, &Opt.ViOpt.SavePos);
+ DialogItemEx *SavePos = Builder.AddCheckbox(MViewConfigSavePos, &ViOpt.SavePos);

- DialogItemEx *SaveShortPos = Builder.AddCheckbox(MViewConfigSaveShortPos, &Opt.ViOpt.SaveShortPos);
+ DialogItemEx *SaveShortPos = Builder.AddCheckbox(MViewConfigSaveShortPos, &ViOpt.SaveShortPos);

Хм? Эт, конечно хорошо бы, но код фара (в частности poscache.cpp) смотрит только на Opt.ViOpt.SaveShortPos.
Так что, на изменения AltShiftF9 из вьювера будет покладено.

Maximus

2011-10-17 21:36

reporter   bugnote:0007891

> индикацию и мне хотелось бы, не знаю куда поставить...
слева от кодовой страницы?

2useven10

2011-10-17 21:37

developer   bugnote:0007892

Last edited: 2011-10-17 21:38

View 2 revisions

ShiftF4 - выбор любого режима, влияет на последующие F4.

$if ((%s & 0x60) != (Viewer.State & 0x60))
  ShiftF4 Home
  $rep ((%s & 0x60) >> 5)
    Down
  $end
  Enter
$end

Maximus

2011-10-17 21:42

reporter   bugnote:0007893

ага, тогда флажок не нужен, вопрос по макросу закрыт.

2useven10

2011-10-17 21:45

developer   bugnote:0007894

насчёт SavePos - да неправ. поправил формально, не подумав, придётся вернуть...
индикацию добавлю.

Maximus

2011-10-17 23:11

reporter   bugnote:0007895

без макроса

каталог с текстовыми файлами. открыли файл, он в "Text",
ShiftF4 -> Dump
Add
открылся следующий файл, режим дампа сохранен (почему кстати? хорошо, если так и задумано).
F4 F4
внезапно возвращается режим "Text"

2useven10

2011-10-17 23:23

developer   bugnote:0007896

скорее это баг, завтра посмотрю.

2useven10

2011-10-18 07:08

developer   bugnote:0007897

была бага, допилил её до фичи - теперь режим будет сохраняться при смене файлов по Gray+ Gray-

Maximus

2011-10-18 13:52

reporter   bugnote:0007902

хочется настройку символа для \x0, "стандартный" не понравился

хоткей для флажка не помешал бы
Visible '\&0'

2useven10

2011-10-19 15:14

developer   bugnote:0007913

build 2229

Maximus

2011-10-19 19:30

reporter   bugnote:0007917

чуть-чуть красивостей - пробел лишний в начале строки

Index: viewer.cpp
===================================================================
--- viewer.cpp (revision 6793)
+++ viewer.cpp (working copy)
@@ -1698,7 +1698,7 @@
         {
             if (FilePos>0 && ViewFile.Opened())
             {
- Up(1); // LastPage = 0
+ Up(1); // LastPage = 0
 
                 if (VM.Hex)
                 {

Denis

2011-10-19 20:24

reporter   bugnote:0007918

Т.е. цикл по F4 Text->Hex->Dump сам по себе - неа? Только через макрос?

Maximus

2011-10-19 22:16

reporter   bugnote:0007920

А чем макрос плох? Если уж нужен тройной цикл - сможешь намакросить.
Да и по моему впечатлению, тройной цикл - зло. Не очень наглядно для бинарных файлов различие Text/Dump. А для текстовых - Dump вообще не нужен.

Maximus

2011-10-19 22:31

reporter   bugnote:0007922

В статусе "d20866" смотрится некрасиво. Пробельчик бы

DrKnS

2011-10-20 08:31

administrator   bugnote:0007925

> хочется настройку символа для \x0, "стандартный" не понравился

Настройку не факт что надо, но сейчас явно не фонтан - в редакторе так визуализируется пробел, что будет приводить к путанице.

2useven10

2011-10-20 08:53

developer   bugnote:0007926

Настройка уже есть: Viewer.ZeroChar, без UI задать можно только ручками.
Специально сделал умолчание как пробел в редакторе, даже макросы повесил на
одну клавишу для их показа (мне удобно :-)
Но каждый может настроить свой символ:
@echo off
set zero_char=0x00B7& rem · middle dot
set sqlite=".\sqlite3.exe"
set dbfile="%APPDATA%\Far Manager\Profile\generalconfig.db"
set /a z=%zero_char%
set script=INSERT OR REPLACE INTO general_config (key,name,value) VALUES ('Viewer','ZeroChar',%z%);
echo %script%
echo %script% | %sqlite% %dbfile% && echo OK

DrKnS

2011-10-20 08:56

administrator   bugnote:0007927

Last edited: 2011-10-20 09:08

View 3 revisions

Может есть смысл уравнять - во вьювере показывать ещё и пробелы/табуляции, а в редакторе \0?

2useven10

2011-10-20 09:06

developer   bugnote:0007928

Last edited: 2011-10-20 09:50

View 5 revisions

Да можно, если есть потребность. Но тогда давайте символ для '\0', желательно присутствующий в Lucida Console. Я перепробовал с десяток, нормального варианта не нашёл.
PS: В дампе и хексе табуляция и так видна, а пробел сам по себе пробел.

Maximus

2011-10-20 14:10

reporter   bugnote:0007931

может для \0 показывать \x2030?
хотя, лично меня и "bullet" устраивает.
"визуализировать" пробел во вьювере, считаю не нужно.
а вот на счет табуляции... может ее стрелкой, как в редакторе показывать?

btw, WinHex визуализизирует точками (обычными) вообще все непечатное...

Maximus

2011-10-20 14:42

reporter   bugnote:0007932

Подумалось... хорошо бы "визуализирующие" символы во вьювере рисовать другим цветом (новый элемент палитры), сереньким например. Только тогда их можно буддет на взгляд отличить от реальных "одноименных".

2useven10

2011-10-20 21:12

developer   bugnote:0007938

Подумалось... тикет отработан.
Последние хотелки, возможно нужны, но они должны быть самостоятельными.
Так что я здесь остановлюсь на

build 2233.

JohnDoe

2013-03-18 12:51

updater   bugnote:0010542

В режиме дампа на линейке отображается хоткей F2 (Wrap/Unwrap).
Надо бы убрать, в дампе это не работает.

alexy

2013-03-18 12:54

administrator   bugnote:0010543

А зачем надо было переотркрывать для этого старый тикет?

JohnDoe

2013-03-18 12:59

updater   bugnote:0010544

А зачем вообще пере-открывать что бы то ни было?
Чтобы держать информацию в одном месте.

Мне всё равно, буду делать как скажете.

2useven10

2013-03-18 13:36

developer   bugnote:0010545

а в hex это работает ?

JohnDoe

2013-03-18 13:37

updater   bugnote:0010546

Нет, тоже убрать бы

2useven10

2013-03-18 13:48

developer   bugnote:0010547

3256

Issue History

Date Modified Username Field Change
2011-10-14 16:29 DrKnS New Issue
2011-10-14 16:29 DrKnS Status new => assigned
2011-10-14 16:29 DrKnS Assigned To => 2useven10
2011-10-17 21:02 2useven10 Note Added: 0007885
2011-10-17 21:06 2useven10 Note Edited: 0007885 View Revisions
2011-10-17 21:07 2useven10 Note Edited: 0007885 View Revisions
2011-10-17 21:08 Maximus Note Added: 0007886
2011-10-17 21:10 Maximus Note Added: 0007887
2011-10-17 21:13 Maximus Note Edited: 0007886 View Revisions
2011-10-17 21:14 2useven10 Note Added: 0007888
2011-10-17 21:18 2useven10 Note Edited: 0007888 View Revisions
2011-10-17 21:25 Maximus Note Added: 0007889
2011-10-17 21:34 Maximus Note Added: 0007890
2011-10-17 21:35 Maximus Note Edited: 0007890 View Revisions
2011-10-17 21:36 Maximus Note Added: 0007891
2011-10-17 21:37 2useven10 Note Added: 0007892
2011-10-17 21:38 2useven10 Note Edited: 0007892 View Revisions
2011-10-17 21:42 Maximus Note Added: 0007893
2011-10-17 21:45 2useven10 Note Added: 0007894
2011-10-17 23:11 Maximus Note Added: 0007895
2011-10-17 23:23 2useven10 Note Added: 0007896
2011-10-18 07:08 2useven10 Note Added: 0007897
2011-10-18 13:52 Maximus Note Added: 0007902
2011-10-19 15:14 2useven10 Note Added: 0007913
2011-10-19 15:15 2useven10 Status assigned => feedback
2011-10-19 19:30 Maximus Note Added: 0007917
2011-10-19 20:24 Denis Note Added: 0007918
2011-10-19 22:16 Maximus Note Added: 0007920
2011-10-19 22:31 Maximus Note Added: 0007922
2011-10-20 08:31 DrKnS Note Added: 0007925
2011-10-20 08:31 DrKnS Status feedback => assigned
2011-10-20 08:53 2useven10 Note Added: 0007926
2011-10-20 08:56 DrKnS Note Added: 0007927
2011-10-20 09:06 2useven10 Note Added: 0007928
2011-10-20 09:08 2useven10 Note Edited: 0007927 View Revisions
2011-10-20 09:08 2useven10 Note Edited: 0007927 View Revisions
2011-10-20 09:08 2useven10 Note Edited: 0007928 View Revisions
2011-10-20 09:09 2useven10 Note Edited: 0007928 View Revisions
2011-10-20 09:09 2useven10 Note Edited: 0007928 View Revisions
2011-10-20 09:50 2useven10 Note Edited: 0007928 View Revisions
2011-10-20 14:10 Maximus Note Added: 0007931
2011-10-20 14:42 Maximus Note Added: 0007932
2011-10-20 21:12 2useven10 Note Added: 0007938
2011-10-20 21:12 2useven10 Status assigned => feedback
2011-10-20 21:17 DrKnS Status feedback => resolved
2011-10-21 06:30 2useven10 Build => 2233
2011-10-21 06:30 2useven10 Status resolved => closed
2011-10-21 06:30 2useven10 Resolution open => fixed
2011-10-21 06:30 2useven10 Fixed in Version => 3.0
2013-03-18 12:47 DrKnS Status closed => new
2013-03-18 12:51 JohnDoe Note Added: 0010542
2013-03-18 12:54 alexy Note Added: 0010543
2013-03-18 12:59 JohnDoe Note Added: 0010544
2013-03-18 13:36 2useven10 Note Added: 0010545
2013-03-18 13:37 JohnDoe Note Added: 0010546
2013-03-18 13:48 2useven10 Note Added: 0010547
2013-03-18 13:48 2useven10 Status new => feedback
2013-03-19 07:43 JohnDoe Status feedback => resolved
2013-03-19 07:50 2useven10 Build 2233 => 3256
2013-03-19 07:50 2useven10 Status resolved => closed